<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="AUTHOR" CONTENT="Vincent Mahe">
	<META NAME="CREATED" CONTENT="20080109;11252100">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20080122;13342000">
</HEAD>
<BODY LANG="fr-FR" BGCOLOR="#ffffff" DIR="LTR">
<P ALIGN=CENTER><FONT FACE="Nimbus Sans L"><FONT SIZE=4>OpenEmbeDD
Models Repository</FONT></FONT></P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>Introduction</FONT></FONT></H1>
<P>The OpenEmbeDD Models Repository is a place dedicated to samples
models corresponding to the various metamodels used in (and developed
for) the OpenEmbeDD platform (<A HREF="http://openembedd.org/"></A><A HREF="http://openembedd.org/"></A><A HREF="http://openembedd.org/">http://openembedd.org</A><A HREF="http://openembedd.org/"></A><A HREF="http://openembedd.org/"></A>).</P>
<P>All models are stored in a SVN repository, with metadata
describing each of them. Some Eclipse tools have been developed in
order to help collation of data and packaging of the models.</P>
<P>A Web site (<A HREF="http://openembedd-rep.gforge.inria.fr/"></A><A HREF="http://openembedd-rep.gforge.inria.fr/"></A><A HREF="http://openembedd-rep.gforge.inria.fr/">http://openembedd-rep.gforge.inria.fr</A><A HREF="http://openembedd-rep.gforge.inria.fr/"></A><A HREF="http://openembedd-rep.gforge.inria.fr/"></A>)
is also attached to the repository in order to provide a concise view
of all models and their metadata.</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>What is the models
repository?</FONT></FONT></H1>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>A place for large
sample models</I></FONT></FONT></H2>
<P><I>Model Driven Engineering</I> (MDE) is based on metamodels. For
MDE developers, the daily work consists in models manipulation. The
models a developer can design himself are generally small and more or
less &laquo;&nbsp;toy&nbsp;&raquo; models. In order to validate
transformations and other modelling tools code, there is a need of
large and exhaustive models.</P>
<P>As a model is useless without informations about its concerns and
contents, we specifically look after the data attached to each model.
The OpenEmbeDD Model Repository defines a dedicated set of data
designed using the <A HREF="http://dublincore.org/"></A><A HREF="http://dublincore.org/"></A><A HREF="http://dublincore.org/">DublinCore</A><A HREF="http://dublincore.org/"></A><A HREF="http://dublincore.org/"></A>
Metadata Initiative. You can find more details about the metadata
structure below in this chapter.</P>
<P>Main part of the models are under OpenSource licenses, and you can
get the license of a desired model on the repository web page
(<A HREF="http://openembedd-rep.gforge.inria.fr/"></A><A HREF="http://openembedd-rep.gforge.inria.fr/"></A><A HREF="http://openembedd-rep.gforge.inria.fr/">http://openembedd-rep.gforge.inria.fr</A><A HREF="http://openembedd-rep.gforge.inria.fr/"></A><A HREF="http://openembedd-rep.gforge.inria.fr/"></A>).</P>
<P>The easier way to get a sample model is to use SVN/Subversion
checkout. Within OpenEmbeDD platform, it is even easier with the
Subclipse plug-in (see <A HREF="http://openembedd.org/Download#platformdevsplugin"></A><A HREF="http://openembedd.org/Download#platformdevsplugin"></A><A HREF="http://openembedd.org/Download#platformdevsplugin">OpenEmbeDD
DEV tools</A><A HREF="http://openembedd.org/Download#platformdevsplugin"></A><A HREF="http://openembedd.org/Download#platformdevsplugin"></A>).
After have parametrized the SVN of the repository, choose the project
of the desired model and check it out.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Tree &amp; names
policy</I></FONT></FONT></H2>
<P>For organisation needs, we design the repository on strict
structural and naming conventions, in order to operate automated data
extraction (for web page) and facilitate information accessibility
for visitors.</P>
<P>Each <B>metamodel</B> (like UML2) has its own Eclipse project,
which is named:</P>
<P>	<FONT FACE="Courier">org.openembedd.</FONT>&lt;metamodel&gt;<FONT FACE="Courier">.samples</FONT></P>
<P>For example, the UML models must be stored into an Eclipse project
named:</P>
<P>	<FONT FACE="Courier">org.openembedd.uml2.samples</FONT></P>
<P>Sample models which concern only a well identified part of the
metamodel can be stored in a separed project with the same naming
constraint, like the UML statecharts part:</P>
<P>	<FONT FACE="Courier">org.openembedd.uml2.statecharts.samples</FONT></P>
<P>Rem: as many real-word models embedd multiple parts of a
metamodel, there will be few separated sample projects. If the number
of samples for a metamodel makes project too large, some models could
be splitted into domains, like
<FONT FACE="Courier">org.openembedd.uml2.software.design.samples</FONT>.</P>
<P>Inside those projects, we consider each &laquo;&nbsp;sample&nbsp;&raquo;
as a (possible collection of) model(s). Each sample must be put in
its own directory. The directory name is free as soon as it respects
alphanumeric use of coding conventions (no dot, no exotic nor
accentuated characters,...). This name must be related with the model
contents (every directory in the repository projects is about a model
so do not use &laquo;&nbsp;model&nbsp;&raquo; in the directory name).</P>
<P>Inside the directory, only one file is mandatory: the metadata
file, which must have the <FONT FACE="Courier"><FONT SIZE=2><I><B>.dublincore</B></I></FONT></FONT>
extension (the main name is free under the same conditions than the
directory). Users will expect a &laquo;&nbsp;doc&nbsp;&raquo; sub
directory to find some informations about the model(s).</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Models metadata</I></FONT></FONT></H2>
<P>We decided to use the <A HREF="http://dublincore.org/"></A><A HREF="http://dublincore.org/"></A><A HREF="http://dublincore.org/">DublinCore</A><A HREF="http://dublincore.org/"></A><A HREF="http://dublincore.org/"></A>
metadata standard for OpenEmbeDD Models Repository samples
information. All DublinCore elements are optional and may be
repeated, which means that your are free to not fill some
informations at all, but we hope you try to give as many significant
informations as you can about the samples you deposit.</P>
<P>DublinCore elements used in the Repository:</P>
<UL>
	<LI><P><B>Title</B> [MANDATORY]: an free expressive name of the
	sample. One qualifier is available: <I>Alternative</I> (any form of
	the title used as a substitute or an alternative to the formal
	title). We will use the first title without alternative qualifier as
	the main title of the metadata.</P>
	<LI><P><B>Subject</B> [MANDATORY]: the topic of the content of the
	sample. It must be keywords in the  repository case, for indexation
	&amp; search purposes.</P>
	<LI><P><B>Description</B> [MANDATORY]: best practice recommandation
	is to use full sentencies. This element would be displayed to users
	on the web page. Two kind of qualifiers are possible: <I>Abstract</I>
	(if you already have a written abstract for the sample) and
	<I>TableOfContents</I> (to use for listed content, as sentencies are
	expected in the main <I>Description</I>).</P>
	<LI><P><B><I>Type</I></B> [MANDATORY]: the nature of the content in
	the ressource. The value describe the detailed type of one kind of
	model contained in the sample (ie: &laquo;&nbsp;UML2 statecharts
	diagram&nbsp;&raquo;). The metamodelVersion attribute give the
	metamodel these models are built on and its version number (in order
	to know if the sample works on a given platform or not).</P>
	<LI><P><B>Relation</B> : different kind of relations (refinements)
	can be registered. You must describe the related ressource and
	choose the closest kind of relation for the <I>refinement</I>
	attribute. If the sample or a model of the sample is not stored on
	the OpenEmbeDD Model Repository, put here its URI, with the <I>Requires</I>
	qualifier.</P>
	<LI><P><B>Creator</B> [MANDATORY]: information about the person or
	entity who created the sample model (name, email, company name, web
	site). It is the initial author or designer of the content.</P>
	<LI><P><B>Coverage</B> : the extent or scope of the sample. For the
	repository samples, it is the related metamodel (like UML2,
	Fiacre,...). At least, one coverage item is required, but you can
	put more (for complex samples which use multiple metamodels). Rem:
	we do not use the two DublinCore refinements (<I>spatial</I> and
	<I>temporal</I>).</P>
	<LI><P><B>Publisher</B> : the person or entity who make the sample
	publicly available [low interest in the models repository case]. If
	it is the same entity as the <I>Creator</I>, do not use <I>Publisher</I>
	element.</P>
	<LI><P><B>Contributor</B> : a person or entity who adds some
	contents to the sample or extends it. Same recommendations than
	<I>Creator</I>. If you create a new sample with some stuff from
	another sample, you become the <I>Creator</I> and the other sample
	<I>Creator</I> become <I>Contributor</I> of yours. A contribution
	can be presented in an additional <I>Description</I>.</P>
	<LI><P><B>Rights</B> [MANDATORY]: information about rights concerns
	of the sample, like Intellectual Property Rights, Copyright,
	licensing,... DublinCore proposes two refinements: <I>AccessRights</I>
	(information about who can access to the resource) and <I>License</I>
	(the legal document which tells what it is possible to do with the
	ressource, possibly an URL to the public document). It is a very
	IMPORTANT information: <B>the license of the sample is mandatory</B>
	for OpenEmbeDD Models Repository (permission to enhance the sample
	depends on the license).</P>
	<LI><P><B>Date</B> [MANDATORY]: a date corresponding to a event in
	the life of the sample. Different kind of refinements can be
	registered. You must enter the date and choose the closest kind of
	date for the <I>refinement</I> attribute. We have interest on
	<I>Created</I> and <I>Modified</I> dates.</P>
	<LI><P><B>Format</B> [MANDATORY]: describe the physical kind of the
	ressource. In our case, it is intersting to give informations about
	the way models are stored (extensions,...). Two qualifiers: <I>Extend</I>
	(the size or duration of ressource) and <I>Medium</I> (specific
	physical carrier of the ressource, like when the ressource is only
	available on DVD).</P>
	<LI><P><B>Identifier</B> : can be instance of a formal
	identification system like URI or ISBN number [low interest in the
	models repository case].</P>
	<LI><P><B>Language</B> : information about the language the sample
	is written in.</P>
</UL>
<P>With respect to DublinCore <I>One-to-One Principle</I>, the
informations inside a sample metadata must concern directly the
current sample version, and must be updated as soon as needed by
changes made upon the sample model(s).</P>
<P>According to DublinCore <I>Dumb-Down Principle</I>, the main
informations must be understandable without qualifiers refinements
(if refined). Main metadata elements must be fullfilled before using
any refinement. For example, the <I>Description</I> element must give
users a view on sample contents (or keywords) despite you join an
<I>Abstract</I> to the description.</P>
<P><B>DEV-note</B>: the use of enumeration for some elements value
has a side effect on the metadata model validation. In the generated
editor, all attributes which type is an enumeration are setted with
the first member of the enumeration as default value. It implies that
they are never seen as &laquo;&nbsp;unset&nbsp;&raquo; by the
validator (when EString attributes with a [1..1] multiplicity are
rejected if they are empty string). So enumerated attributes must be
seen as facilities for users and limitations but not as effective
constraints.</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>HowTo get a model from
the repository?</FONT></FONT></H1>
<P>All sample projects are Eclipse projects available on the
OpenEmbeDD Model Repository which is a SVN repository.</P>
<P>So you need Eclipse with EMF support (or basic OpenEmbeDD user
platform) and the Subclipse plugin (from OpenEmbeDD Developers tools
for exemple) + the plugins (and modeler) corresponding to the
metamodel(s) used in the desired sample.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Define the SVN
repository (once)</I></FONT></FONT></H2>
<P>Open Eclipse and then right-click in the Package Explorer. Select
the &laquo;&nbsp;New Project&nbsp;&raquo; item and go to the SVN
&laquo;&nbsp;Checkout&nbsp;&raquo;.</P>
<P><IMG SRC="../img/Subclipse1.png" NAME="graphics1" ALIGN=LEFT WIDTH=533 HEIGHT=508 BORDER=0><BR CLEAR=LEFT>Create
the repository location which corresponds to the OpenEmbeDD Sample
Models Repository.</P>
<P><IMG SRC="../img/Subclipse2.png" NAME="graphics2" ALIGN=LEFT WIDTH=533 HEIGHT=440 BORDER=0><BR CLEAR=LEFT>The
anonymous access to the repository can be done with the SVN address 
<A HREF="svn://scm.gforge.inria.fr/svn/openembedd-rep"></A><A HREF="svn://scm.gforge.inria.fr/svn/openembedd-rep"></A><A HREF="svn://scm.gforge.inria.fr/svn/openembedd-rep"><FONT FACE="Courier 10 Pitch"><FONT SIZE=2>svn://scm.gforge.inria.fr/svn/openembedd-rep</FONT></FONT></A><A HREF="svn://scm.gforge.inria.fr/svn/openembedd-rep"></A><A HREF="svn://scm.gforge.inria.fr/svn/openembedd-rep"></A>.
No password will be demanded, but you will not be able to commit
models.</P>
<P>If you are a referenced developer, you can access the repository
through a company firewall with the HTTPS protocol. The secured SVN
address is <A HREF="https://scm.gforge.inria.fr/svn/openembedd-rep/"></A><A HREF="https://scm.gforge.inria.fr/svn/openembedd-rep/"></A><A HREF="https://scm.gforge.inria.fr/svn/openembedd-rep/"><FONT FACE="Courier 10 Pitch"><FONT SIZE=2>https://scm.gforge.inria.fr/svn/openembedd-rep/</FONT></FONT></A><A HREF="https://scm.gforge.inria.fr/svn/openembedd-rep/"></A><A HREF="https://scm.gforge.inria.fr/svn/openembedd-rep/"></A>.</P>
<P><IMG SRC="../img/Subclipse3.png" NAME="graphics3" ALIGN=LEFT WIDTH=525 HEIGHT=284 BORDER=0><BR CLEAR=LEFT>When
you click on the Finish button, the connection begin.</P>
<P><IMG SRC="../img/Subclipse4.png" NAME="graphics4" ALIGN=LEFT WIDTH=540 HEIGHT=243 BORDER=0><BR CLEAR=LEFT>In
case other than anonymous, you will have to enter your gForge login
name and password.</P>
<H2><IMG SRC="../img/Subclipse5.png" NAME="graphics6" ALIGN=LEFT WIDTH=404 HEIGHT=218 BORDER=0><BR CLEAR=LEFT><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Select
and check out the desired sample project(s)</I></FONT></FONT></H2>
<P>Then you will get a view on the currently stored &quot;projects&quot;.</P>
<P><IMG SRC="../img/Subclipse6.png" NAME="graphics7" ALIGN=LEFT WIDTH=455 HEIGHT=335 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>You can choose the sample project you want (only one in the
picture) and click on Finish button.</P>
<P><IMG SRC="../img/Subclipse7.png" NAME="graphics9" ALIGN=LEFT WIDTH=525 HEIGHT=500 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>Usually, there is no needs for changes, so just click on Finish
button. You must get the desired project into your workspace.</P>
<P><IMG SRC="../img/Subclipse8.png" NAME="graphics5" ALIGN=LEFT WIDTH=408 HEIGHT=74 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>HowTo make a deposit?</FONT></FONT></H1>
<P>A contribution must be done as a new directory in an existing
samples project (like org.openembedd.uml2.sample) or a new project
(only if any project exists corresponding to the sample main
metamodel). See the <I><B>Tree &amp; names policy</B></I> in the <I><B>What
is the models repository?</B></I> Chapter.</P>
<P>We illustrate the process with an example based on an UML2 simple
model designed with OpenEmbeDD Topcased UML2 modeler. The sample
itself is two files:</P>
<UL>
	<LI><P>inheritance1.uml (the UML2 model in a XMI format)</P>
	<LI><P>inheritance1.umldi (graphical part of the model).</P>
</UL>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>First step: a
&laquo;&nbsp;metamodel&nbsp;&raquo; project</I></FONT></FONT></H2>
<P>As our sample is an UML2 model, we need to embedd it in an UML2
samples project.</P>
<P>With respect to the repository naming policy, we created a new
project in Eclipse, named <FONT FACE="Courier 10 Pitch"><FONT SIZE=2>org.openembedd.uml2.sample</FONT></FONT>.</P>
<P>You must use an existing sample project if it corresponds to the
metamodel used in the sample.</P>
<P>Rem : we (the repository maintainers) will probably split large
projects concerning wide metamodels like UML2 into subprojects when
the number of samples increases.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Second step: a sample
directory</I></FONT></FONT></H2>
<P>As each sample (model or set of models) must be put in its own
directory at the root of a metamodel project, just create a new
directory, with respect to naming policy.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Third step: the
metadata</I></FONT></FONT></H2>
<P>You must create a .dublincore metadata file at the root of the
second step directory, because the automated web pages generator will
search metadata in the first level directories in the projects. You
can name the metadata file with respect to naming policy.</P>
<P>The DublinCore editor is embedded in the OpenEmbeDD Model Samples
Repository feature you can get from <A HREF="http://openembedd.org/experimental/update"></A><A HREF="http://openembedd.org/experimental/update"></A><A HREF="http://openembedd.org/experimental/update">OpenEmbeDD
experimental update site</A><A HREF="http://openembedd.org/experimental/update"></A><A HREF="http://openembedd.org/experimental/update"></A>
(in DevTools part). In the sample directory, right click and then
choose <I>New</I> -&gt; <I>Other</I> -&gt; <I>OpenEmbeDD</I> -&gt;
<I>DublinCore Model Metadata</I>. The editor builts up a new metadata
with all required items. You must fulfill them and check the model
validity (right click on <I>Metadata</I> and <I>Validate</I>).</P>
<P>If your model sample is always stored on the web and you want not
duplicate it, you must add in your metadata file a <I><B>Relation</B></I>
(the value must be the URI of the sample) with the <I><B>ExternalStorage</B></I><B>
qualifier</B>. You do not need the fourth step.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Fourth step: the
sample</I></FONT></FONT></H2>
<P>You can now store your model(s) and their full documentation (with
some code samples if you like) into the sample directory.</P>
<P>You are free to put your model(s) inside it or in subdirectories,
depending the degree of complexity of the sample and the way you want
to be user-friendly.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Fifth step: commit the
project</I></FONT></FONT></H2>
<P>Once you have managed and verified your sample stuff, you must
commit the metamodel project to the OpenEmbeDD Model Samples
Repository, through SVN, in order to publish the sample.</P>
<P>A automated tool will extract informations from the .dublincore
file and generate the corresponding HTML page and will insert links
into search pages. This job is ran each nigth (around 0 GMT).</P>
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>Legal</FONT></FONT></H1>
<P>Copyright INRIA 2008</P>
<P>License: Eclipse Public License</P>
<P>Authors:	Vincent Mah&eacute; &lt;<A HREF="mailto:vmahe@irisa.fr"></A><A HREF="mailto:vmahe@irisa.fr"></A><A HREF="mailto:vmahe@irisa.fr">vmahe@irisa.fr</A><A HREF="mailto:vmahe@irisa.fr"></A><A HREF="mailto:vmahe@irisa.fr"></A>&gt;</P>
</BODY>
</HTML>